import QtQuick 1.0
import QtMultimediaKit 1.1

Item {
    id: homePage
    width: 854;height: 480

    signal hide(string i)

    property bool isSound: true
    property bool kedian: true

    property int fdnum: 1
    property int snum: 1
    property string sywenjian: "sound/flying.mp3"

    property bool isBack

    anchors.fill: parent

    Image {
        anchors.fill: parent
        source: "img/shouye/background.png"
        fillMode: Image.Stretch
    }
    Image {
        anchors.fill:parent
        source:"img/shouye/startPage.png"
        fillMode: Image.Stretch
    }

    Image {
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: parent.top
        anchors.topMargin: 50
        source: "img/shouye/title.png"
    }

    Image {
        id:startButt
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 150
        source:"img/shouye/start"+snum+".png"
        MouseArea {
            enabled: kedian
            anchors.fill: parent
            onClicked: {
                kedian=false
                fdStartAnimation.start()
            }
        }
    }
//    Flipable {
//        id:startButt
//        width: 347;height: 150
//        anchors.horizontalCenter: parent.horizontalCenter
//        anchors.bottom: parent.bottom
//        anchors.bottomMargin: 150
//        property bool flipped: false
//        front: Image{
//            source: "img/shouye/start_normal.png"
//            anchors.centerIn: parent
//        }
//        back:Image {
//            source: "img/shouye/start_click.png"
//            anchors.centerIn: parent
//        }
//        transform: Rotation {
//            id: rotation
//            origin.x: startButt.width/2
//            origin.y: startButt.height/2
//            axis.x: 0; axis.y: 1; axis.z: 0     // set axis.y to 1 to rotate around y-axis
//            angle: 0    // the default angle
//        }

//        states: State {
//            name: "back"
//            PropertyChanges {
//                target: rotation;
//                angle: 180
//            }
//            when: startButt.flipped
//        }

//        transitions: Transition {
//            NumberAnimation {
//                target: rotation;
//                property: "angle";
//                duration: 1000
//            }
//        }

//        MouseArea {
//            enabled: kedian
//            anchors.fill: parent
//            onClicked: {
//                kedian=false
//                startButt.flipped = true
//                startAnimation.start()
//            }
//        }
//    }

    Row {
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 60
        spacing: 30
        Image {
            id: soundButt
            source:"img/shouye/sound"+(isSound ? "on" : "off" )+".png"
            MouseArea {
                enabled: kedian
                anchors.fill: parent
                onClicked: {
                    isSound=!isSound
                    if(isSound){
                        homeMusic.play()
                    }
                    else {
                        homeMusic.stop()
                    }
                }
            }
        }
        Image {
            id:aboutButt
            source: "img/shouye/about_namal.png"
            MouseArea {
                enabled: kedian
                anchors.fill: parent
                onPressed: {
                    aboutButt.source="img/shouye/about_click.png"
                }
                onReleased: {
                    aboutButt.source="img/shouye/about_namal.png"
                }
                onClicked: {
                    kedian=false
                    hide("about")
                }
            }
        }
    }

    Image {
        id:feidao
        source: "img/youxi/knife"+fdnum+".png"
        x:733;y:0
        opacity: 0
    }

    SequentialAnimation {
        id:fdStartAnimation
        PropertyAction{
            target: homePage
            property: "fdnum"
            value: 5
        }
        PropertyAction {
            target: feidao
            property: "x"
            value: 733
        }
        PropertyAction {
            target: feidao
            property : "y"
            value: 0
        }
        PropertyAction {
            target: feidao
            property: "opacity"
            value: 1
        }
        ScriptAction {
            script: flySound()
        }
        ParallelAnimation {
            NumberAnimation {
                target: feidao
                property: "x"
                to:318
                duration: 400
            }
            NumberAnimation {
                target: feidao
                property: "y"
                to:245
                duration: 400
            }
        }
        PropertyAction {
            target: homePage
            property: "snum"
            value: 2
        }
        PropertyAction {
            target: feidao
            property: "opacity"
            value: 0
        }
        ScriptAction {
            script: buttSound()
        }
        PauseAnimation {
            duration: 500
        }

        ScriptAction {
            script:hide("start")
        }
    }

    SequentialAnimation {
        id:startAnimation
        PauseAnimation {
            duration: 1000
        }
        ScriptAction{
            script: hide("start")
        }
    }
    Timer {
        id:startTime
        interval: 1000
        running: true
        onTriggered: {
            homeMusic.play()
        }
    }

    Audio {
        id:homeMusic
        source: "sound/opening.mp3"
        onStarted: {
            console.log("$$$$$$homeMusic$$$$$$$$$")
        }

//        playing: true
        onStopped: {
            console.log("============music==============")
            if(isSound){
                homeMusic.play()
            }
        }
    }

    Audio {
        id:music1
        source: sywenjian
    }

//    Component.onCompleted: {
//        homeMusic.play()
//    }
//    function openingSound(){
//        homeMusic.stop()
//        homeMusic.play()
//    }

    function flySound(){
        if(isSound){
            sywenjian="sound/mute.mp3"
            music1.play()
            music1.stop()
            sywenjian="sound/flying.mp3"
            music1.play()
        }
    }

    function buttSound(){
        if(isSound){
            sywenjian="sound/mute.mp3"
            music1.play()
            music1.stop()
            sywenjian="sound/button.mp3"
            music1.play()
        }
    }
    //gzf add
    function homemusicstop(){
//        homeMusic.stop();
//        music1.stop();
        homeMusic.volume=0
    }
    function homemusicstart(){
//        if(isSound){
//            homeMusic.play()
//        }
        homeMusic.volume=0.5
    }

    states: [
        State {
            name: "shang"
            PropertyChanges {
                target: homePage
                opacity:0
//                y:-480
            }
        }
    ]


    transitions: [
        Transition {
            NumberAnimation {
                target: homePage;
                property: "opacity"
//                property: "y";
                duration: 100
            }
        }
    ]

}
