import QtQuick 1.1
import com.nokia.meego 1.0
import QtMultimediaKit 1.1
import 'Lulu.js' as Lulu

Page {
    id:mainPage
    width: 854;height: 480
    property string f1name: "img/youxi/g"+fnum1+".png"  //第一个水果路径
    property string f2name: "img/youxi/g"+fnum2+".png"  //第二个水果路径
    property string f3name: "img/youxi/g"+fnum3+".png"  //低三个水果路径
    property int fnum1: 1  //判断是那种水果
    property int fnum2: 1  //判断是那种水果
    property int fnum3: 1  //判断是那种水果
    property int f1X: 0  //第一个水果的X坐标
    property int f1Y: 0  //第一个水果的Y坐标
    property int f1Z: 0  //第一个水果的Z坐标
    property int f2X: 0  //第二个水果的X坐标
    property int f2Y: 0  //第二个水果的Y坐标
    property int f2Z: 1  //第二个水果的Z坐标
    property int f3X: 0  //第三个水果的X坐标
    property int f3Y: 0  //第三个水果的Y坐标
    property int f3Z: 2  //第三个水果的Z坐标
    property int daoX: 0 //留在转盘上的刀柄X坐标
    property int daoY: 0  //留在转盘上的刀柄Y坐标
    property int f1angle: 0  //第一个水果的角度
    property int f2angle: 0  //第二个水果的角度
    property int f3angle: 0  //第三个水果的角度
    property bool f1show: false  //判断第一个水果是否显示
    property bool f2show: false  //判断第二个水果是否显示
    property bool f3show: false  //判断第三个水果是否显示

    property int sjX: 0  //随机变量，用来给水果出现的X坐标
    property int sjY: 0  //随机变量，用来给水果出现的Y坐标

//    property int rolationSpeed: currentScore < 500 ? (currentScore<300 ? 20000 : 12000) : 8000 //转盘旋转频率
    property int rolationSpeed: 20000

    property string mysoure: "img/youxi/knife"+knum+".png"  //刀路径
    property int knum: 1  //第几章刀图片
    property int pressX: 0  //手指点击的X坐标
    property int pressY: 0  //手指点击的Y坐标

    property string leftname: "img/youxi/g"+count+"_left.png"  //水果左半边路径
    property string rightname: "img/youxi/g"+count+"_right.png"  //水果右半边路径
    property int count: 1  //判断是哪种水果
    property int leftX: 0  //左半边X坐标
    property int rightX: 0  //右半边X坐标
    property int mfY: 0  //Y坐标

    property string hitname: "img/youxi/"+hnum+"hit.png"  //连击图片路径
    property int hnum: 2  // 判断是哪张连击图片

    property int maxRecord: result.zuigaodefen //最高纪录
    property int currentScore: 0 //当前分数
    property int jiafenNum: 10
    property int addScore: 0  //增加多少分
    property int currentBlood: 0 //当前血数
    property int addBlood: 0  //增加多少血
    property int batterNum: 0  //连击次数
    property int maxBatterNum: 0  //最高连击次数
    property int hitNum: 0  // 总共击中次数
    property int dartsNum: 0 // 总共飞镖次数
    property bool dzsg: false  //判断打中水果
    property int youxisj: 0

    property int extranum: 1 //判断额外的加分为25或50

    property int mushu: 1  //幕的帧

    property int yeChange: 12  //标记页面切换

    property bool mkedian: false  //游戏是否可点

    property int buttX: 0  //飞刀在按钮上的x坐标
    property int buttY: 0  //飞刀在按钮上的y坐标

    property int muSelect: 0 //选择第几个转场动画

    property int zjbl: 20000  //转盘转动频率

    property bool soundOn: home.isSound  //声音是否有
    property string musiclj: "sound/flying.mp3"
    property string musiclj2: "sound/speedup.mp3"

    property int rabbitNum: 1  //兔子的帧
    property string rabbitName: "img/animation/"+rabbitNum+".png"  //兔子路径
    property int rabbitStartCount: 1  //兔子动画起始帧
    property int rabbitEndCount: 2  //兔子动画结束帧


    //shu xing guan lian qian zhi jiance hanshu;
    property string mm: set();
    function set(){
        if(!platformWindow.active) {

            home.homemusicstop();
            result.resultmusicstop();
            mainpagemusicstop();
            if(mkedian==true){
                mkedian=false
                gameTime.stop()
                showTime.stop()
                turnAnimation.pause()
                pauseAnimation.start()
//                return "1";
            }
            return "1";
        }
        result.resultmusicstart();
        home.homemusicstart();
        mainpagemusicstart();

        return "2";
    }

    onCurrentScoreChanged: {
        if(currentScore>8000){
           zjbl=5000
        }
        else if(currentScore>4000){
            zjbl=6000
        }
        else if(currentScore>2000){
            zjbl=7000
        }
        else if(currentScore>1000){
            zjbl=8000
        }
        else if(currentScore>500){
            zjbl=12000
        }
        else if(currentScore>300){
            zjbl=15000
        }
        else if(currentScore>100){
            zjbl=18000
        }
        else if(currentScore>=0){
            zjbl=20000
        }
    }
    onZjblChanged: {
        console.log("**********speedUp*************")
        speedupSound()
        turnAnimation.pause()
        rolationSpeed=zjbl
        turnAnimation.resume()
        speedUpAnimation.start()
    }

   //手点击区域为全屏幕
    MouseArea {
        enabled: mkedian
        anchors.fill:parent
        onPressed: {
             if(knifeAnimation.running==false){
                 pressX=mouseX
                 pressY=mouseY
                 if(daoTime.running==true){
                     daoTime.stop()
                     daobing.visible=false
                 }
                 knifeAnimation.start()
            }
        }
    }

    //背景图片
    Image {
        id: bj
        source: "img/youxi/background.png"
        Image {
            id: wutai
            anchors.bottom: parent.bottom
            anchors.horizontalCenter: parent.horizontalCenter
            source: "img/youxi/wutai.png"
        }

        Image {
            id: pause_butt
            width: 81;height: 81
            smooth: true
            source: "img/youxi/pause_icon.png"
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.bottomMargin: 35
            anchors.leftMargin: 40
            MouseArea {
                anchors.fill: parent
                enabled: mkedian
                onClicked: {
                    mkedian=false
                    gameTime.stop()
                    showTime.stop()
                    turnAnimation.pause()
                    buttX=57
                    buttY=364
                    muSelect=1
                    fdButtAnimation.start()
                }
            }
        }

        Image {
            id: again_butt
            source: "img/youxi/again_icon.png"
            anchors.bottom: parent.bottom
            anchors.right: parent.right
            anchors.bottomMargin: 35
            anchors.rightMargin: 40
            MouseArea {
                anchors.fill: parent
                enabled: mkedian
                onClicked: {
                   mkedian=false
                    gameTime.stop()
                    showTime.stop()
                    turnAnimation.stop()
                    buttX=750
                    buttY=364
                    muSelect=3
                    fdButtAnimation.start()
                }
            }
        }
    }

    //转盘图片
    Image {
        id: zhuanpan
        source: "img/youxi/disc.png"
        anchors.centerIn: parent
        transformOrigin: Item.Center
        Image {
            id: rabbit
            y: -16
            source: rabbitName  /*"img/youxi/rabbit.png"*/
            anchors.horizontalCenter: parent.horizontalCenter
        }

        Image {
            id:daobing
            source: "img/youxi/knife6.png"
            x:daoX-23;y:daoY-26
            visible: false
        }

        Image {
            id: fruit1
            visible: f1show
            source: f1name
            x:f1X;y:f1Y;z:f1Z
            rotation: f1angle
        }

        Image {
            id: fruit2
            visible: f2show
            source: f2name
            x:f2X;y:f2Y;z:f2Z
            rotation: f2angle
        }

        Image {
            id: fruit3
            visible: f3show
            source: f3name
            x:f3X;y:f3Y;z:f3Z
            rotation: f3angle
        }
    }

    Image {
        id:speedUpImage
        source: "img/youxi/speedUp.png"
        x:600;y:-159
        transformOrigin: Item.Top
    }

//    Grid {
//        id:tbcolumn
//        anchors.left:parent.left
//        anchors.top:parent.top
//        anchors.leftMargin: 34
//        anchors.topMargin: 10
//        columns: 2
//        rows:3
//        spacing: 12
//        Image {
//            id:cupImg
//            source: "img/youxi/cup.png"
//        }
//        Text {
//            id:recordText
//            color: "#d8ac0d"
//            anchors.verticalCenter: cupImg.verticalCenter
//            text:maxRecord==0 ? "000":maxRecord
//            font.bold: true
//            font.pixelSize: 23
//            font.family: "Segoe Print"
//        }
//        Image {
//            id:fruImg
//            source: "img/youxi/fruit_small.png"
//        }
//        Text {
//            id:scoreText
//            color: "#d7ac0e"
//            anchors.verticalCenter: fruImg.verticalCenter
//            text:currentScore==0 ? "000":currentScore
//            font.pixelSize: 23
//            font.bold: true
//            font.family: "Segoe Print"
//            wrapMode: Text.WordWrap
//        }

//        Image {
//            id:radishImg
//            source: "img/youxi/radish_small.png"
//        }

//        Text {
//            id: bloodText
//            color: "#d8ac0d"
//            anchors.verticalCenter: radishImg.verticalCenter
//            text: currentBlood
//            font.pixelSize: 23
//            font.bold: true
//            font.family: "Segoe Print"
//        }
//    }
    Image {
        x:34;y:10
        id:cupImg
        source: "img/youxi/cup.png"
    }
    Text {
        id:recordText
        x:80
        color: "#d8ac0d"
        anchors.verticalCenter: cupImg.verticalCenter
        text:maxRecord==0 ? "000":maxRecord
        font.bold: true
        font.pixelSize: 23
        font.family: "Segoe Print"
    }
    Image {
        id:fruImg
        x:34;y:62
        source: "img/youxi/fruit_small.png"
    }
    Text {
        id:scoreText
        color: "#d7ac0e"
        x:80
        anchors.verticalCenter: fruImg.verticalCenter
        text:currentScore==0 ? "000":currentScore
        font.pixelSize: 23
        font.bold: true
        font.family: "Segoe Print"
        wrapMode: Text.WordWrap
    }

    Image {
        id:radishImg
        x:34;y:114
        source: "img/youxi/radish_small.png"
    }

    Text {
        id: bloodText
        color: "#d8ac0d"
        x:100
        anchors.verticalCenter: radishImg.verticalCenter
        text: currentBlood
        font.pixelSize: 23
        font.bold: true
        font.family: "Segoe Print"
    }



    //标记图片
    Image {
        id:mark
        source: "img/youxi/targetX.png"
        opacity: 0
    }

    Image {
        id:diskitImage
        source: "img/youxi/blood_large.png" //"img/youxi/diskit.png"
        x:leftX;y:mfY
        scale: 0.5
        opacity: 0
    }

    Image {
        id: addScoreImage
        source: "img/youxi/jia"+jiafenNum+".png"
        x:leftX;y:mfY
        opacity: 0

    }

    Image {
        id:extraScoreImage
        x: 160
        y: 50
        source:"img/youxi/fen"+extranum+".png"
        opacity:0
    }

    Image {
        id:hitImage
        source: hitname
        x:leftX;y:mfY
        opacity: 0
    }
    Image {
        id:bloodImage
        source: "img/youxi/blood.png"
        x:leftX;y:mfY
        opacity: 0
    }


    //被劈开的左半边水果图片
    Image {
        id: fleft
        source: leftname
        x:leftX;y:mfY
        opacity: 0
    }

    //被劈开的右半边水果图片
    Image {
        id: fright
        source: rightname
        x:rightX;y:mfY
        opacity: 0
    }


    function minit(){
        currentScore=0
        currentBlood=0
        maxBatterNum=0
        hitNum=0
        dartsNum=0
        youxisj=0
        rabbitNum=1
        zhuanpan.rotation=0
    }

    //转盘动画
    NumberAnimation {
        id:turnAnimation
        loops: Animation.Infinite
        target: zhuanpan
        property: "rotation"
        from: 0
        to:359
        duration: rolationSpeed
    }

    SequentialAnimation {
        id:speedUpAnimation
        NumberAnimation {
            target: speedUpImage
            property: "y"
            to:0
            duration: 300
            easing.type: Easing.OutBounce
        }
        NumberAnimation {
            target: speedUpImage
            property: "rotation"
            to:45
            duration: 300
        }
        NumberAnimation {
            target: speedUpImage
            property: "rotation"
            to:-30
            duration: 500
        }
        NumberAnimation {
            target: speedUpImage
            property: "rotation"
            to:15
            duration: 300
        }
        NumberAnimation {
            target: speedUpImage
            property: "rotation"
            to:0
            duration: 100
        }
        PauseAnimation { duration: 500 }
        NumberAnimation {
            target: speedUpImage
            property: "y"
            to:-159
            duration: 300
        }
    }

    //飞刀动画
    SequentialAnimation {
        id:knifeAnimation
        PropertyAction {
            target: mark
            property: "x"
            value: pressX-17
        }
        PropertyAction {
            target: mark
            property: "y"
            value: pressY-17
        }
        PropertyAction {
            target: mark
            property: "opacity"
            value: 1
        }
        ScriptAction {
            script: fSound()
        }
        PauseAnimation {
            duration: 200
        }
        PropertyAction {
            target: knife
            property: "opacity"
            value: 1
        }
        ParallelAnimation {
            NumberAnimation {
                target: mainPage
                property: "knum"
                from:1
                to:4
                duration: 300  //400
            }
            NumberAnimation {
                target: knife
                property: "x"
                from:733
                to:650
                duration: 300  //400
            }
            NumberAnimation {
                target: knife
                property: "y"
                from:0
                to:150
                duration: 300  //400
            }
        }
        PropertyAction{
            target: mainPage
            property: "knum"
            value: 5
        }
        PropertyAction {
            target: mark
            property: "opacity"
            value: 0
        }
        ParallelAnimation {
            NumberAnimation {
                target: knife
                property: "x"
                to:pressX-23
                duration: 200
            }
            NumberAnimation {
                target: knife
                property: "y"
                to:pressY-28
                duration: 200
            }
        }
        PropertyAction {
            target: knife
            property: "opacity"
            value: 0
        }
        ScriptAction {
            script: Lulu.hitAction()
        }
    }

   //水果被劈开动画
    SequentialAnimation {
        id:splitAnimation
        PropertyAction {
            target: fleft
            property: "opacity"
            value:1.0
        }
        PropertyAction {
            target: fright
            property:"opacity"
            value: 1.0
        }
        ParallelAnimation {
            NumberAnimation {
                target: fleft
                property: "rotation"
                to:-150
                duration: 500  //400
            }
            NumberAnimation {
                target: fright
                property: "rotation"
                to:150
                duration: 500  //400
            }
            NumberAnimation {
                target: fleft
                property: "x"
                to:leftX-20
                duration: 500  //400
            }
            NumberAnimation {
                target: fright
                property: "x"
                to:rightX+20
                duration: 500  //400
            }
            NumberAnimation {
                target: fleft
                property: "y"
                to:mfY+60
                duration: 500  //400
            }
            NumberAnimation {
                target: fright
                property: "y"
                to:mfY+60
                duration: 500  //400
            }
            NumberAnimation {
                target: fleft
                property: "scale"
                to:1.3
                duration: 500 //400
            }
            NumberAnimation {
                target: fright
                property: "scale"
                to:1.3
                duration: 500 //400
            }

        }

        ParallelAnimation {
            NumberAnimation {
                target: fleft
                property: "opacity"
                to:0
                duration: 100
            }
            NumberAnimation {
                target: fright
                property: "opacity"
                to:0
                duration: 100
            }
        }
        PropertyAction {
            target: fleft
            property: "scale"
            value: 1
        }
        PropertyAction {
            target: fright
            property: "scale"
            value: 1
        }
    }

    //连击提示动画
    SequentialAnimation {
        id:batterAnimation
        PropertyAction {
            target: hitImage
            property: "opacity"
            value: 1.0
        }
        ParallelAnimation {
            NumberAnimation {
                target: hitImage
                property: "x"
                to:700
                duration: 200  //300
            }
            NumberAnimation {
                target: hitImage
                property: "y"
                to:240
                duration: 200  //300
            }
            NumberAnimation {
                target: hitImage
                property: "scale"
                to:2
                duration: 200  //300
            }
        }
        PauseAnimation {
            duration: 400
        }
        NumberAnimation {
            target: hitImage
            property: "opacity"
            to:0
            duration: 100
        }
        PropertyAction {
            target: hitImage
            property: "scale"
            value: 1
        }

    }

    //加分提示动画
    SequentialAnimation {
        id:addScoreAnimation
        PropertyAction {
            target: addScoreImage
            property: "opacity"
            value: 1.0
        }
        PropertyAction {
            target: mainPage
            property: "dzsg"
            value: false
        }
        ParallelAnimation {
            NumberAnimation {
                target: addScoreImage
                property: "y"
                to:mfY-60
                duration: 200  //300
            }
            NumberAnimation {
                target: addScoreImage
                property: "scale"
                to:2
                duration: 200  //300
            }
        }
        PauseAnimation {
            duration: 400
        }
        NumberAnimation {
            target: addScoreImage
            property: "opacity"
            to:0
            duration: 100
        }
        PropertyAction {
            target: addScoreImage
            property: "scale"
            value: 1
        }
    }

    //打到药包提示动画
    SequentialAnimation {
        id:addBloodAnimation
        PropertyAction {
            target: bloodImage
            property: "opacity"
            value: 1.0
        }
        ParallelAnimation {
        NumberAnimation {
            target: bloodImage
            property: "x"
            to:leftX-100
            duration: 200
        }
        NumberAnimation {
            target: bloodImage
            property: "scale"
            to:2
            duration: 200
        }
        }
        PauseAnimation {
            duration:  400 //500
        }
        NumberAnimation {
            target: bloodImage
            property: "opacity"
            to:0
            duration: 100
        }
        PropertyAction {
            target: bloodImage;
            property: "scale";
            value: 1
        }
    }

    //分数变化动画
    SequentialAnimation {
        id:scoreShowAnimation
        NumberAnimation {
            target: scoreText
            property: "opacity"
            to:0
            duration: 200
        }
        PropertyAction {
            target: mainPage;
            property: "currentScore";
            value: currentScore+addScore
        }
        NumberAnimation {
            target: scoreText
            property: "opacity"
            to:1
            duration: 200
        }
        PropertyAction {
            target: mainPage
            property: "addScore"
            value: "0"
        }
    }

    //血数变化动画
    SequentialAnimation {
        id:bloodShowAnimation
        NumberAnimation {
            target: bloodText
            property: "opacity"
            to:0
            duration: 200
        }
        PropertyAction {
            target: mainPage;
            property: "currentBlood";
            value: currentBlood+addBlood
        }
        NumberAnimation {
            target: bloodText
            property: "opacity"
            to:1
            duration: 200
        }
        PropertyAction {
            target: mainPage
            property: "addBlood"
            value: "0"
        }
    }

    //额外的加分动画
    SequentialAnimation {
        id:extraScoreAnimation
        ScriptAction {
            script: comboSound()
        }
        ParallelAnimation {
            NumberAnimation {
                target: extraScoreImage
                property: "opacity"
                to:1
                duration: 200
            }
            NumberAnimation {
                target: extraScoreImage
                property: "scale"
                to:2
                duration: 200
            }
        }
        PauseAnimation {
            duration: 500
        }
        ParallelAnimation {
            NumberAnimation {
                target: extraScoreImage
                property: "x"
                to:90
                duration: 500
            }
            NumberAnimation {
                target: extraScoreImage
                property: "scale"
                to:0.1
                duration: 500
            }
        }
        PropertyAction {
            target: extraScoreImage
            property: "opacity"
            value: 0
        }
        PropertyAction {
            target: extraScoreImage
            property: "scale"
            value: 1
        }
        PropertyAction {
            target: extraScoreImage
            property: "x"
            value: 160
        }

    }

    //补血提示动画
    SequentialAnimation {
        id:diskitAnimation
        PropertyAction {
            target: diskitImage
            property: "x"
            value: leftX+20
        }
        PropertyAction {
            target: diskitImage
            property: "y"
            value: mfY-20
        }
        NumberAnimation {
            target:diskitImage
            property: "opacity"
            to:1
            duration: 75
        }
        NumberAnimation {
            target: diskitImage
            property: "opacity"
            to:0
            duration: 75
        }
        PropertyAction {
            target: diskitImage
            property: "x"
            value: leftX-20
        }
        PropertyAction {
            target: diskitImage
            property: "y"
            value: mfY-40
        }
        NumberAnimation {
            target:diskitImage
            property: "opacity"
            to:1
            duration: 75
        }
        NumberAnimation {
            target: diskitImage
            property: "opacity"
            to:0
            duration: 75
        }
        PropertyAction {
            target: diskitImage
            property: "x"
            value: leftX+20
        }
        PropertyAction {
            target: diskitImage
            property: "y"
            value: mfY-60
        }
        NumberAnimation {
            target:diskitImage
            property: "opacity"
            to:1
            duration: 75
        }
        NumberAnimation {
            target: diskitImage
            property: "opacity"
            to:0
            duration: 75
        }
        PropertyAction {
            target: diskitImage
            property: "x"
            value: leftX-20
        }
        PropertyAction {
            target: diskitImage
            property: "y"
            value: mfY-80
        }
        NumberAnimation {
            target:diskitImage
            property: "opacity"
            to:1
            duration: 75
        }
        NumberAnimation {
            target: diskitImage
            property: "opacity"
            to:0
            duration: 75
        }
        PropertyAction {
            target: diskitImage
            property: "x"
            value: leftX+20
        }
        PropertyAction {
            target: diskitImage
            property: "y"
            value: mfY-100
        }
        NumberAnimation {
            target:diskitImage
            property: "opacity"
            to:1
            duration: 75
        }
        NumberAnimation {
            target: diskitImage
            property: "opacity"
            to:0
            duration: 75
        }
    }
//    SequentialAnimation {
//        id:diskitAnimation
////        ScriptAction {
////            script: comboSound()
////        }
//       ParallelAnimation {
//           NumberAnimation {
//               target: diskitImage
//               property: "x"
//               from: 520
//               to:550
//               duration: 300
//           }
//           NumberAnimation {
//               target: diskitImage
//               property: "y"
//               from:130
//               to:110
//               duration: 300
//           }
//           NumberAnimation {
//               target: diskitImage
//               property: "opacity"
//               to:1
//           }
//       }
//       ParallelAnimation {
//           NumberAnimation {
//               target: diskitImage
//               property: "x"
//               to:580
//               duration: 300
//           }
//           NumberAnimation {
//               target: diskitImage
//               property: "y"
//               to:140
//               duration: 300
//           }
//           NumberAnimation {
//               target: diskitImage
//               property: "opacity"
//               to:0
//           }
//       }
//    }

    SequentialAnimation {
        id:rabbitAnimation
        NumberAnimation {
            target: mainPage
            property: "rabbitNum"
            from:rabbitStartCount
            to:rabbitEndCount
            duration: 900
        }
    }

    SequentialAnimation {
        id:rabbitDieAnimation
        NumberAnimation {
            target: mainPage
            property: "rabbitNum"
            from:3
            to:5
            duration:500
        }
        PauseAnimation { duration: 200 }
        ScriptAction {
            script: rabbitDieSound()
        }
        NumberAnimation {
            target: mainPage
            property: "rabbitNum"
            from: 1
            to: 2
            duration: 500
        }
        PauseAnimation { duration: 1500 }
        ScriptAction {
            script: curtainAnimation.start()
        }
    }

    //暂停一秒
    SequentialAnimation {
        id:ztAnimation
        PauseAnimation {
            duration:1000
        }
        ScriptAction{
            script: curtainAnimation.start()
        }
    }


    //第一个水果消失定时器
    Timer {
        id:time1
        interval:  3000 //4000
        onTriggered: {
            if(f1show){
                f1show=false
            }
        }
    }

    //第二个水果消失定时器
    Timer {
        id:time2
        interval: 3000  //4000
        onTriggered: {
            if(f2show){
                f2show=false
            }
        }
    }

    //第三个水果消失定时器
    Timer {
        id:time3
        interval: 3000  //4000
        onTriggered: {
            if(f3show){
                f3show=false
            }
        }
    }

    //刀柄消失定时器
    Timer {
        id:daoTime
        interval: 1200  //1500
        onTriggered: {
            if(daobing.visible){
                daobing.visible=false
            }
        }

    }

     //每隔1.5秒出现一个水果定时器
    Timer {
        id:showTime
        repeat: true
        interval: 1200  //1500
        triggeredOnStart: true
        onTriggered: {
            Lulu.getFruitXY()
            Lulu.picShow()
        }
    }

    //游戏运行时间
    Timer {
        id:gameTime
        repeat: true
        interval: 1000
        onTriggered:{
            youxisj=youxisj+1
        }
    }

    //首页
    Home {
        id:home
        onHide: {
            switch(i){
            case "about" :yeChange=14;break;
            case "start" :yeChange=12;break;
            }
            curtainAnimation.start()
        }
    }

    //关于页面
    About {
        id:about
        onAbout_back: {
            yeChange=41
            buttX=67
            buttY=20
            muSelect=0
            fdButtAnimation.start()
        }
    }

    //成绩页面
    Result {
        id:result
        dangqiandefen: currentScore
        yongshi: youxisj
        lianjicishu: maxBatterNum
        feidaocishu: dartsNum
        jizhongcishu: hitNum
        resultSoundOn: home.isSound
        onResultHide: {
            switch (j){
            case "back" : {
                yeChange=32;
                buttX=750
                buttY=364
                muSelect=0
            }break;
            case "home" : {
                yeChange=31;
                buttX=57
                buttY=364
                muSelect=0
            }break;
            }
            fdButtAnimation.start()
        }
    }

    //幕图片
    Image {
        id:curtainImage
        anchors.fill: parent
        source: "img/mu/"+mushu+".png"
        opacity: 0
    }

    //暂停恢复启动按钮图片
    Image {
        id:resumeImage
        width:81;height:81
        smooth:true
        anchors.centerIn: parent
        source:"img/youxi/start_icon.png"
        opacity:0
        MouseArea {
            anchors.fill: parent
            onClicked: {
                buttX=404
                buttY=200
                muSelect=2
                fdButtAnimation.start()
            }
        }
    }

    //刀图片
    Image {
        id:knife
        source: mysoure
        x:854;y:-103
    }

    //飞刀动画
//    SequentialAnimation {
//        id:fdButtAnimation

//        ScriptAction {
//            script: fSound()
//        }

//        PauseAnimation {
//            duration: 200
//        }
//        PropertyAction {
//            target: knife
//            property: "x"
//            value: 733
//        }
//        PropertyAction {
//            target: knife
//            property : "y"
//            value: 0
//        }
//        PropertyAction {
//            target: knife
//            property: "opacity"
//            value: 1
//        }
//        ParallelAnimation {
//            NumberAnimation {
//                target: mainPage
//                property: "knum"
//                from:1
//                to:4
//                duration: 400
//            }
//            NumberAnimation {
//                target: knife
//                property: "x"
//                to:650
//                duration: 400
//            }
//            NumberAnimation {
//                target: knife
//                property: "y"
//                to:150
//                duration: 400
//            }
//        }
//        PropertyAction{
//            target: mainPage
//            property: "knum"
//            value: 5
//        }
//        ParallelAnimation {
//            NumberAnimation {
//                target: knife
//                property: "x"
//                to:buttX
//                duration: 200
//            }
//            NumberAnimation {
//                target: knife
//                property: "y"
//                to:buttY
//                duration: 200
//            }
//        }
//        PropertyAction{
//            target: mainPage
//            property: "knum"
//            value: 6
//        }
//        ScriptAction {
//            script: bSound()
//        }

//        NumberAnimation {
//            target: knife
//            property: "y"
//            to:buttY+40
//            duration: 100
//        }
//        NumberAnimation {
//            target: knife;
//            property: "opacity";
//            to: 0;
//            duration: 100 }

//        ScriptAction {
//            script: buttAction()
//        }
//    }

    SequentialAnimation {
        id:fdButtAnimation

        ScriptAction {
            script: fSound()
        }

        PauseAnimation {
            duration: 200
        }
        PropertyAction {
            target: knife
            property: "x"
            value: 733
        }
        PropertyAction {
            target: knife
            property : "y"
            value: 0
        }
        PropertyAction {
            target: knife
            property: "opacity"
            value: 1
        }
        PropertyAction{
            target: mainPage
            property: "knum"
            value: 5
        }
        ParallelAnimation {
            NumberAnimation {
                target: knife
                property: "x"
                to:buttX
                duration: 400
            }
            NumberAnimation {
                target: knife
                property: "y"
                to:buttY
                duration: 400
            }
        }
        PropertyAction{
            target: mainPage
            property: "knum"
            value: 6
        }
        ScriptAction {
            script: bSound()
        }

        NumberAnimation {
            target: knife
            property: "y"
            to:buttY+40
            duration: 100
        }
        NumberAnimation {
            target: knife;
            property: "opacity";
            to: 0;
            duration: 100 }

        ScriptAction {
            script: buttAction()
        }
    }

    //幕转场动画1
    SequentialAnimation {
        id:curtainAnimation
        PauseAnimation { duration: 200 }
        PropertyAction {
            target: mainPage
            property: "mushu"
            value: 1
        }
        NumberAnimation {
            target: curtainImage
            property: "opacity"
            to:1
            duration: 200
        }
        NumberAnimation {
            target: mainPage
            property: "mushu"
            to:5
            duration: 800
        }
        ScriptAction {
            script: zhuanhuan()
        }
        PauseAnimation {
            duration: 500
        }
        NumberAnimation {
            target: mainPage
            property: "mushu"
            to:8
            duration: 900
        }
        NumberAnimation {
            target: curtainImage
            property: "opacity"
            to:0
            duration: 300
        }
        ScriptAction {
            script: chushihua()
        }
    }

    //幕转场动画2
    SequentialAnimation {
        id:pauseAnimation
        PauseAnimation { duration: 200 }
        PropertyAction {
            target: mainPage
            property: "mushu"
            value: 8
        }
        NumberAnimation {
            target: curtainImage
            property: "opacity"
            to:1
            duration: 300
        }
        NumberAnimation {
            target: mainPage
            property: "mushu"
            to:5
            duration: 900
        }
        NumberAnimation {
            target: resumeImage
            property: "opacity"
            to:1
            duration: 500
        }
    }

    //幕转场动画3
    SequentialAnimation {
        id:resumeAnimation
        PauseAnimation { duration: 200 }
        NumberAnimation {
            target: resumeImage
            property: "opacity"
            to:0
            duration: 500
        }
        NumberAnimation {
            target: mainPage
            property: "mushu"
            to:8
            duration: 900
        }
        NumberAnimation {
            target: curtainImage
            property: "opacity"
            to:0
            duration: 300
        }
        ScriptAction {
            script: rst()
        }
    }

    //幕转场动画4
    SequentialAnimation {
        id:againAnimation
        PauseAnimation { duration: 200 }
        PropertyAction {
            target: mainPage
            property: "mushu"
            value: 8
        }
        NumberAnimation {
            target: curtainImage
            property: "opacity"
            to:1
            duration: 300
        }
        NumberAnimation {
            target: mainPage
            property: "mushu"
            to:5
            duration: 900
        }
        ScriptAction {
            script: minit()
        }
        PauseAnimation {
            duration: 500
        }
        NumberAnimation {
            target: mainPage
            property: "mushu"
            to:8
            duration: 900
        }
        NumberAnimation {
            target: curtainImage
            property: "opacity"
            to:0
            duration: 300
        }
        ScriptAction {
            script: mst()
        }
    }

    function buttAction(){
        switch(muSelect){
        case 0:curtainAnimation.start();break;
        case 1:pauseAnimation.start();break;
        case 2:resumeAnimation.start();break;
        case 3:againAnimation.start();break;
        }
    }


    function zhuanhuan(){
        switch(yeChange){
        case 12:{
            home.state="shang";
            console.log("=========start to game=============")
            minit()
        }break;
        case 14: {
            about.state="zhong"
            console.log("=========start to about=============")
        };break;
        case 41: {
            about.state=""
            console.log("=========about to start==============")
        };break;
        case 23: {
            result.state="zhong"
            console.log("=========game to result===============")
        };break;
        case 31: {
            result.state=""
            home.state=""
            result.init()
            console.log("=========result to start================")
        };break;
        case 32: {
            result.state=""
            minit()
            result.init()
            console.log("============result to game===============")
        };break;
        }
    }

    function chushihua(){
        switch(yeChange){
        case 12 :{
            home.snum=1
            mst()
        };break;
        case 14 :{
            about.kedian=true
        };break;
        case 41 : {
            home.kedian=true
        };break;
        case 23 : {
            result.qidong()
        };break;
        case 31 : {
            home.kedian=true
        };break;
        case 32 : {
            mst()
        };break;
        }
    }

    function mst(){
        mkedian=true
        showTime.start()
        gameTime.start()
        turnAnimation.start()
    }
    function rst(){
        mkedian=true
        showTime.start()
        gameTime.start()
        turnAnimation.resume()
    }

    function fSound(){
        if(soundOn){
            console.log("********flyingSound***********")
            gameMusic.stop()
            musiclj="sound/mute.mp3"
            gameMusic.play()
            gameMusic.stop()
            gameMusic="sound/flying.mp3"
            gameMusic.play()
        }
    }

    function bSound(){
        if(soundOn){
            musiclj="sound/mute.mp3"
            gameMusic.play()
            gameMusic.stop()
            musiclj="sound/button.mp3"
            gameMusic.play()
        }
    }

    function hitFruitSound(){
        if(soundOn){
            musiclj="sound/mute.mp3"
            gameMusic.play()
            gameMusic.stop()
            musiclj="sound/hit_fruit.mp3"
            gameMusic.play()
        }
    }

    function hitRabbitSound(){
        if(soundOn){
            musiclj="sound/mute.mp3"
            gameMusic.play()
            gameMusic.stop()
            musiclj="sound/hit_rabbit.mp3"
            gameMusic.play()
        }
    }

    function missedSound(){
        if(soundOn){
            musiclj="sound/mute.mp3"
            gameMusic.play()
            gameMusic.stop()
            musiclj="sound/missed.mp3"
            gameMusic.play()
        }
    }

    function comboSound(){
        if(soundOn){
            musiclj2="sound/mute.mp3"
            gameMusic2.play()
            gameMusic2.stop()
            musiclj2="sound/combo.mp3"
            gameMusic2.play()
        }
    }

    function speedupSound(){
        if(soundOn){
            musiclj2="sound/mute.mp3"
            gameMusic2.play()
            gameMusic2.stop()
            musiclj2="sound/speedup.mp3"
            gameMusic2.play()
        }
    }

    function rabbitDieSound(){
        if(soundOn){
            musiclj2="sound/mute.mp3"
            gameMusic2.play()
            gameMusic2.stop()
            musiclj2="sound/rabbit_die.mp3"
            gameMusic2.play()
        }
    }



    Audio {
        id:gameMusic
        source: musiclj
    }

    Audio {
        id:gameMusic2
        source: musiclj2
    }
    /*gzf add */
    function mainpagemusicstop(){
        gameMusic.volume =0;
        gameMusic2.volume=0;
    }
    function mainpagemusicstart(){
        gameMusic.volume = 0.5
        gameMusic2.volume = 0.5
    }

    Component.onCompleted: {
//        home.openingSound()
        result.getRecord()
    }
//    Component.onDestruction:{
//        console.log("444444444444444444444444444444444")
//        result.saveRecord()
//    }


//    Component.onCompleted: {
//        turnAnimation.start()
//        showTime.start()
//    }




}
