import QtQuick 1.0
import QtMultimediaKit 1.1

Item {
    id:resultPage
   width: 854;height: 480
   x:854
   property int zuigaodefen: 0
   property int dangqiandefen: 0
   property int yongshi: 0
   property int lianjicishu: 0
   property int feidaocishu: 0
   property int jizhongcishu:0

   property int shuzi: 0
   property int scoreShowTime: dangqiandefen/1000>=1 ? 4000 :(dangqiandefen/100>=1 ? 1000 : 100)
//   property int scoreShowTime:{
//       if(dangqiandefen/1000>=1){
//           return 4000
//       }
//       else if(dangqiandefen/100>=1){
//           return 3000
//       }
//       else if(dangqiandefen/10>=1){
//           return 2000
//       }
//       else {
//           return 1000

//       }
//   }


   property int wanwei: Math.floor(shuzi/10000)
   property int qianwei: Math.floor((shuzi-Math.floor(shuzi/10000)*10000)/1000)
   property int baiwei: Math.floor((shuzi%1000)/100)
   property int shiwei: Math.floor((shuzi%100)/10)
   property int gewei: shuzi%10

   property bool kedian: false

   property string sylujing: "sound/ending.mp3"
   property bool resultSoundOn: true

   property bool scoreCanShow: false


   signal resultHide(string j)


   MouseArea {
       anchors.fill: parent
       onClicked: {
           if(scoreCanShow){
               scoreCanShow=false
               scoreShowAnimation.stop()
               shuzi=dangqiandefen
               dataAnimation.start()
           }
       }
   }


   Image {
       id:bg
       anchors.fill: parent
       source: "img/jieguo/background.png"
   }

   Image {
       anchors.horizontalCenter: parent.horizontalCenter
       anchors.top: parent.top
       anchors.topMargin: 50
       source: "img/jieguo/title.png"
   }

   Image {
       id:cup
       x: 45
       y: 35
       anchors.left: parent.left
       anchors.leftMargin: 45
       anchors.top: parent.top
       anchors.topMargin: 35
       source: "img/jieguo/cup.png"
   }

   Text {
       id:recordText
       x: 93
       y: 30
       text:{
           if(zuigaodefen/1000>=1){
               return zuigaodefen
           }
           else if(zuigaodefen/100>=1){
               return "0"+zuigaodefen
           }
           else if(zuigaodefen/10>=1){
               return "00"+zuigaodefen
           }
           else {
               return "000"+zuigaodefen

           }
       }

       color: "#d7ac0e"
       font.pixelSize: 24
       font.bold: true
       font.family: "Segoe Print"
   }

   Image {
       id:resultImage
       x: 157
       source: "img/jieguo/score.png"
       anchors.horizontalCenter: parent.horizontalCenter
       y: -336
   }

   Image {
       id:wimage
       x:427;y:166
       source: "img/jieguo/"+wanwei+".png"
       opacity: 0
   }

   Image {
       id:qimage
       x:475;y:166
       source: "img/jieguo/"+qianwei+".png"
       opacity: 0
   }
   Image {
       id:bimage
       x:523;y:166
       source: "img/jieguo/"+baiwei+".png"
       opacity: 0
   }
   Image {
       id:simage
       x:571;y:166
       source: "img/jieguo/"+shiwei+".png"
       opacity: 0
   }
   Image {
       id:gimage
       x:619;y:166
       source: "img/jieguo/"+gewei+".png"
       opacity:0
   }

   Text {
       id:timeText
       x:627    //427
       y:285     //379
       color: "#600909"
       text:{
           if(yongshi>3599){
               yongshi=3599
           }
           if(yongshi/600>=1){
               return Math.floor(yongshi/60)+":"+(yongshi%60<10 ? ("0"+yongshi%60):yongshi%60)
           }
           else if(yongshi/60>=1){
               return "0"+Math.floor(yongshi/60)+":"+(yongshi%60<10 ? ("0"+yongshi%60):yongshi%60)
           }
           else if(yongshi/10>=1){
               return "00:"+yongshi%60
           }
           else {
               return "00:0"+yongshi
           }
       }

       font.bold: true
       font.italic: true
       font.family: "Comic Sans MS"
       font.pixelSize: 22
       opacity: 0
   }

   Text {
       id:comboHitText
       x: 627    //427
       y: 316     //379
       color: "#600909"
       text:lianjicishu
       font.bold: true
       font.italic: true
       font.family: "Comic Sans MS"
       font.pixelSize: 22
       opacity: 0
   }
   Text {
       id:dartsText
       x: 627
       y: 347
       color: "#600909"
       text:feidaocishu
       font.bold: true
       font.italic: true
       font.family: "Comic Sans MS"
       font.pixelSize: 22
       opacity: 0
   }
   Text {
       id:hitText
       x: 627
       y: 378
       color: "#600909"
       text:jizhongcishu
       font.bold: true
       font.italic: true
       font.family: "Comic Sans MS"
       font.pixelSize: 22
       opacity: 0
   }

   Image {
       id:newRecordImage
       x: 466  //854
       y: 282  //-162
       scale: 0.1
       opacity: 0
       source: "img/jieguo/newRecord.png"
   }

   Image {
       id:homeButt
       source: "img/jieguo/home_icon.png"
       x:330;y:-81
       MouseArea {
           enabled: kedian
           anchors.fill: parent
           onClicked: {
               kedian=false
               resultHide("home")
           }
       }
   }

   Image {
       id:backButt
       source: "img/jieguo/back_icon.png"
       x:443;y:-81
       MouseArea {
           enabled: kedian
           anchors.fill: parent
           onClicked: {
               kedian=false
               resultHide("back")
           }
       }
   }


   SequentialAnimation {
      id:resultShowAnimation
      ScriptAction {
          script: endSound()
      }

   NumberAnimation {
       target: resultImage
       property: "y"
       from:-336
       to:144
       duration: 500
       easing.type: Easing.OutBounce
   }
   ParallelAnimation {
       NumberAnimation {
           target: wimage
           property: "opacity"
           to:1
           duration: 200
       }
       NumberAnimation {
           target: wimage
           property: "y"
           to:192
           duration: 200
           easing.type: Easing.OutBounce
       }
   }

   ParallelAnimation {
   NumberAnimation {
       target: qimage
       property: "opacity"
       to:1
       duration: 200
   }
   NumberAnimation {
       target: qimage
       property: "y"
       to:192
       duration:200
       easing.type: Easing.OutBounce
   }
   }
   ParallelAnimation {
   NumberAnimation {
       target: bimage
       property: "opacity"
       to:1
       duration: 200

   }
   NumberAnimation {
       target: bimage
       property: "y"
       to:192
       duration: 200
       easing.type: Easing.OutBounce
   }
   }
   ParallelAnimation {
   NumberAnimation {
       target: simage
       property: "opacity"
       to:1
       duration: 200
   }
   NumberAnimation {
       target: simage
       property: "y"
       to:192
       duration:200
       easing.type: Easing.OutBounce
   }
   }
   ParallelAnimation {
   NumberAnimation {
       target: gimage
       property: "opacity"
       to:1
       duration: 200
   }
   NumberAnimation {
       target: gimage
       property: "y"
       to:192
       duration:200
       easing.type: Easing.OutBounce
   }
   }
   PropertyAction {
       target:resultPage
       property: "scoreCanShow"
       value: true
   }
   NumberAnimation {
       target: resultPage
       property: "shuzi"
       from:0
       to:dangqiandefen
       duration: scoreShowTime //5000
   }
   PropertyAction {
       target: resultPage
       property: "scoreCanShow"
       value: false
   }
   ScriptAction {
       script: dataAnimation.start()
   }
   }

   SequentialAnimation {
       id:dataAnimation
       PauseAnimation { duration: 200 }
       NumberAnimation {
           target: timeText
           property: "opacity"
           to:1
           duration: 100
       }
       NumberAnimation {
           target: timeText
           property: "x"  //"y"
           to:427 //285
           duration:300
           easing.type: Easing.OutBounce
       }
       NumberAnimation {
           target: comboHitText
           property: "opacity"
           to:1
           duration: 100
       }
       NumberAnimation {
           target: comboHitText
           property: "x"  //"y"
           to:427  //316
           duration:300
           easing.type: Easing.OutBounce
       }
       NumberAnimation {
           target: dartsText
           property: "opacity"
           to:1
           duration: 100
       }
       NumberAnimation {
           target: dartsText
           property: "x"
           to:427
           duration:300
           easing.type: Easing.OutBounce
       }
       NumberAnimation {
           target: hitText
           property: "opacity"
           to:1
           duration: 100
       }
       NumberAnimation {
           target: hitText
           property: "x"
           to:427
           duration:300
           easing.type: Easing.OutBounce
       }
       ScriptAction {
           script: isNewRecode()
       }
   }

   SequentialAnimation {
       id:newRecodeAnimation
//       ParallelAnimation {
//           NumberAnimation {
//               target: newRecordImage
//               property: "x"
//               to:466
//               duration: 300
//               easing.type: Easing.OutBounce
//           }
//           NumberAnimation {
//               target: newRecordImage
//               property: "y"
//               to:282
//               duration: 300
//               easing.type: Easing.OutBounce
//           }
//       }
       ScriptAction {
           script: newRecordSound()
       }
       PropertyAction {
           target: newRecordImage
           property: "opacity"
           value: 1
       }
       NumberAnimation {
           target: newRecordImage
           property: "scale"
           to:1
           duration: 300
           easing.type: Easing.OutBounce
       }

       NumberAnimation {
           target: recordText
           property: "font.pixelSize"
           to:60 //45
           duration: 100
       }
       NumberAnimation {
           target: recordText
           property: "opacity"
           to:0
           duration: 200
       }
       PropertyAction {
           target: resultPage;
           property: "zuigaodefen";
           value: dangqiandefen
       }
       NumberAnimation {
           target: recordText
           property: "opacity"
           to:1
           duration: 200
       }
       NumberAnimation {
           target: recordText
           property: "font.pixelSize"
           to:24
           duration: 100
       }
       ScriptAction {
           script: saveRecord()
       }

       ScriptAction {
           script:buttAnimation.start()
       }
   }

   SequentialAnimation {
       id:buttAnimation
       ParallelAnimation {
           NumberAnimation {
               target: homeButt
               property: "y"
               to:369
               duration: 500
               easing.type: Easing.OutBounce
           }
           NumberAnimation {
               target: backButt
               property: "y"
               to:369
               duration: 500
               easing.type: Easing.OutBounce
           }
       }
       ParallelAnimation {
           NumberAnimation {
               target: homeButt
               property: "x"
               to:40
               duration: 1000
           }
           NumberAnimation {
               target: backButt
               property: "x"
               to:733
               duration: 1000
           }
           NumberAnimation {
               target: homeButt
               property: "rotation"
               to: -720
           }
           NumberAnimation {
               target: backButt
               property: "rotation"
               to:720
           }
       }
       PropertyAction {
           target: resultPage
           property: "kedian"
           value: true
       }
   }

   function isNewRecode(){
       if(dangqiandefen>zuigaodefen){
           newRecodeAnimation.start()
       }
       else {
           buttAnimation.start()
       }
   }

   Audio {
       id:scoreMusic
       source: sylujing
   }
   /*gzf add*/
   function resultmusicstop(){
       scoreMusic.volume  =0;
   }
   function resultmusicstart(){
       scoreMusic.volume  =0.5;
   }

   function endSound(){
       if(resultSoundOn){
           sylujing="sound/mute.mp3"
           scoreMusic.play()
           scoreMusic.stop()
           sylujing="sound/ending.mp3"
           scoreMusic.play()
       }
   }

   function newRecordSound(){
       if(resultSoundOn){
           scoreMusic.stop()
           sylujing="sound/mute.mp3"
           scoreMusic.play()
           scoreMusic.stop()
           sylujing="sound/new_record.mp3"
           scoreMusic.play()
       }
   }

   function init(){
       shuzi=0
       resultImage.y=-336
       wimage.opacity=0
       qimage.opacity=0
       bimage.opacity=0
       simage.opacity=0
       gimage.opacity=0
       wimage.y=166
       qimage.y=166
       bimage.y=166
       simage.y=166
       gimage.y=166
       timeText.opacity=0
       comboHitText.opacity=0
       dartsText.opacity=0
       hitText.opacity=0
       timeText.x=627
       comboHitText.x=627
       dartsText.x=627
       hitText.x=627
//       newRecordImage.x=854
//       newRecordImage.y=-162
       newRecordImage.scale=0.1
       newRecordImage.opacity=0
       homeButt.x=330
       homeButt.y=-81
       homeButt.rotation=0
       backButt.x=443
       backButt.y=-81
       backButt.rotation=0
   }

   function qidong(){
       resultShowAnimation.start()
       console.log("=====scoreShowTime===="+scoreShowTime)
   }

   function saveRecord(){
       console.log("!!!!!!!!!!!!!!!!!baocun1!!!!!!!!!!!!")
       var db = openDatabaseSync("Rabbit", "1.0", "The RPS QML SQL!", 100);
       db.transaction(
           function(tx) {
                console.log("!!!!!!!!!!baocun2!!!!!!!!!!!!!")
               // Create the database if it doesn't already exist
                tx.executeSql('CREATE TABLE IF NOT EXISTS FLY(score TEXT)');
               // Add (another) greeting row
                var rs = tx.executeSql('SELECT * FROM FLY');

                if(rs.rows.length == 0){
                    console.log("INSERT INTO FLY VALUES===================>" + zuigaodefen)
                    tx.executeSql('INSERT INTO FLY VALUES(?)', [zuigaodefen]);
                    console.log("dddeeefff+++++++++++++")
                }else{
                    console.log("UPDATE FLY SET score ===================>" + zuigaodefen)
                    tx.executeSql('UPDATE FLY SET score = ? ',[zuigaodefen]);
                    console.log("mmmmmmmmmmmnnnnnnnnnnn")
                }
           }
       )
   }

   function getRecord(){
       var db = openDatabaseSync("Rabbit", "1.0", "The RPS QML SQL!", 100);
       db.transaction(
           function(tx){
                // Create the database if it doesn't already exist
                tx.executeSql('CREATE TABLE IF NOT EXISTS FLY(score TEXT)');
                // Add (another) greeting row
                var rs = tx.executeSql('SELECT * FROM FLY');
                if(rs.rows.length == !0){
                    zuigaodefen=rs.rows.item(0).score
                    console.log("abcdefg<<<<<<<<<<<>>>>>")
                }
            }
       )
   }

//   Component.onCompleted: {
//       getRecord()
//   }
//   Component.onDestruction:{
//       saveRecord()
//   }


   states:[
       State {
           name: "zhong"
           PropertyChanges {
               target: resultPage
               x:0
           }
       }
   ]


   transitions: [
       Transition {
           NumberAnimation {
               target: resultPage;
               property: "x";
               ///to: value;
               duration: 100
               //easing.type: Easing.OutBounce;
           }
       }
   ]







}
